> ## Documentation Index
> Fetch the complete documentation index at: https://stytch.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Bitbucket

> Start the Bitbucket OAuth flow

A client-side endpoint (can only be queried from the user's browser) that starts the Bitbucket OAuth flow. This endpoint generates the Bitbucket OAuth URL with all of the required fields and redirects a user to that URL. From there, the user signs into their Bitbucket Account before getting redirected back to Stytch. After verifying the request, Stytch immediately redirects the user back to the `login_redirect_url` or `signup_redirect_url` URLs provided.

#### Scopes

By default our Bitbucket OAuth integration includes `open_id`, `email`, and `profile` scopes. You may add any additional Bitbucket API scopes (see [here](https://developer.atlassian.com/cloud/bitbucket/rest/intro/#bitbucket-oauth-2-0-scopes) for a complete list) as a space separated list in the `custom_scopes` query parameter of `/oauth/bitbucket/start`.

#### Additional provider parameters

Any parameters that should be forwarded to the OAuth provider can be passed as query parameters with the `provider_` prefix. For example, some OAuth providers support a `login_hint` parameter that allows you to pre-populate the OAuth login flow with a suggested email address. To specify the `login_hint` parameter in your OAuth request, you'd you'd include `provider_login_hint=exampleHint` as a query parameter. We recommend consulting each OAuth provider's documentation for a list of supported parameters.

#### Next steps

Once the user successfully authenticates with Bitbucket, they'll be redirected to the redirect URL that you provided at the start of the OAuth flow with a Stytch OAuth token. Collect the token from the URL query parameters, and call [Authenticate OAuth](/api-reference/consumer/api/oauth/authenticate) token to complete authentication.

### Path Parameters

<ParamField path="public_token" type="string" required>
  The public token found in your [Stytch Dashboard](https://stytch.com/dashboard). Since this endpoint must be called client-side, the public token authenticates the request instead of the project ID and secret.
</ParamField>

<ParamField path="login_redirect_url" type="string">
  The URL Stytch redirects to after the OAuth flow is completed for a user that already exists. This URL should be a route in your application which will run authenticate the oauth token and finish the login.

  The URL must be configured as a Login URL in the [Redirect URL page](https://stytch.com/dashboard/redirect-urls). If the field is not specified, the default Login URL will be used.
</ParamField>

<ParamField path="signup_redirect_url" type="string">
  The URL Stytch redirects to after the OAuth flow is completed for a user that does not yet exist. This URL should be a route in your application which will run authenticate the oauth token and finish the login.

  The URL must be configured as a Signup URL in the [Redirect URL page](https://stytch.com/dashboard/redirect-urls). If the field is not specified, the default Signup URL will be used.
</ParamField>

<ParamField path="custom_scopes" type="string">
  A space-separated list of custom scopes that you'd like to include. Note that this list must be URL encoded (e.g. the spaces must be expressed as %20).
</ParamField>

<ParamField path="provider_[parameter_name]" type="string">
  Any parameters that should be forwarded to the OAuth provider can be passed as query parameters with the `provider_` prefix. For example, some OAuth providers support a `login_hint` parameter that allows you to pre-populate the OAuth login flow with a suggested email address. To specify the `login_hint` parameter in your OAuth request, include `provider_login_hint=exampleHint` as a query parameter.

  We recommend consulting each OAuth provider's documentation for a list of supported parameters.
</ParamField>

<ParamField path="code_challenge" type="string">
  A base64url encoded SHA256 hash of a one time secret used to validate that the request starts and ends on the same device.
</ParamField>

<ParamField path="oauth_attach_token" type="string">
  A single-use token for connecting the Stytch User selection from an OAuth Attach request to the corresponding OAuth Start request.
</ParamField>

### Response

<ResponseField name="redirect_url" type="string">
  The url to redirect to. This should be done automatically by the browser.
</ResponseField>

<ResponseField name="status_code" type="number">
  The HTTP status code of the response. Stytch follows standard HTTP response status code patterns, e.g. 2XX values
  equate to success, 3XX values are redirects, 4XX are client errors, and 5XX are server errors.
</ResponseField>

<ResponseField name="request_id" type="string">
  Globally unique UUID that is returned with every API call. This value is important to log for debugging purposes; we
  may ask for this value to help identify a specific API call when helping you debug an issue.
</ResponseField>

<Panel>
  <RequestExample>
    ```js theme={null}
    // Client-side in the user's browser
    const response = await fetch('https://test.stytch.com/v1/public/oauth/bitbucket/start?public_token=YOUR_PUBLIC_TOKEN&login_redirect_url=https://yourapp.com/login&signup_redirect_url=https://yourapp.com/signup', {
      method: 'GET',
    });
    ```
  </RequestExample>

  <ResponseExample>
    ```json 302 theme={null}
      {
        "status_code": 302,
        "request_id": "request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141",
        "redirect_url": "https://bitbucket.com/api/oauth2/authorize?access_type=offline&client_id=example-client-id&redirect_uri=https%3A%2F%2Fstytch.com%2Fv1%2Foauth%2Foauth-callback-test-d868b16b-3ecd-49ac-7fc6-e3d1051c5d65&response_type=code&scope=identify%3Aemail&state=example-state",
      }
    ```

    ```json 400 theme={null}
    {
      "status_code": 400,
      "request_id": "request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141",
      "error_type": "duplicate_email",
      "error_message": "A user with the specified email already exists for this project.",
      "error_url": "https://stytch.com/docs/api/errors/400"
    }
    ```

    ```json 401 theme={null}
    {
      "status_code": 401,
      "request_id": "request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141",
      "error_type": "unauthorized_credentials",
      "error_message": "Unauthorized credentials.",
      "error_url": "https://stytch.com/docs/api/errors/401"
    }
    ```

    ```json 429 theme={null}
    {
      "status_code": 429,
      "request_id": "request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141",
      "error_type": "too_many_requests",
      "error_message": "Too many requests have been made.",
      "error_url": "https://stytch.com/docs/api/errors/429"
    }
    ```

    ```json 500 theme={null}
    {
      "status_code": 500,
      "request_id": "request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141",
      "error_type": "internal_server_error",
      "error_message": "Oops, something seems to have gone wrong, please reach out to support@stytch.com to let us know what went wrong.",
      "error_url": "https://stytch.com/docs/api/errors/500"
    }
    ```
  </ResponseExample>
</Panel>
